var backWidth = 220;
var backHeight = 290;
var frontWidth = 222;
var frontHeight = 111;
var backShown = false;
var interval = null;

var city = "Home";
var cityLat = 0;
var cityLong = -getTimezoneOffset(new Date()) / 12 / 60 * 180;

var timeZone = 0;
var dst = false;
var sunrise = 6 * 60;
var sunset = 18 * 60;
var dawn = 60;
var dawn2 = 15;
var nightColor = [0, 0, 0];
var dayColor = [255, 255, 255];
var dawnColorRise = [20, 20, 180];
var dawnColorSet = [160, 128, 100];
var dayTextColor = [0, 0, 0];//"#202020";
var dawnTextColorRise = [60, 60, 60];
var dawnTextColorSet = [160, 128, 100];
var nightTextColor = [255, 255, 255];//"#E0E0E0";
var isNight = true;
var lastDay = -1;
var infoIndex = 0;
var lastSeconds = 0;
var show12Clock = false;
var showSeconds = true;

var pane = document.getElementById("BackPane");
var stars = document.getElementById("StarsPane");
var glow = document.getElementById("GlowPane");
var moon = document.getElementById("Moon");
var santa = document.getElementById("Santa");
var sun = document.getElementById("Sun");
var clouds = document.getElementById("CloudsPane");
var clock = document.getElementById("ClockPane");

var testmin = 0;
var testh = 24;

var tableTd = ["tc", "tr", "lc", "rc", "bl", "bc"];
var tableImg = ["tl", "br"];

var daysAfterMonth = [0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334];

var specials = [-9.5, -3.5, 3.5, 4.5, 5.5, 5.75, 6.5, 8.75, 9.5, 10.5, 11.5, 12.75];

function setup() {
  if (window.widget) {
    if (!widget.context) {
      document.getElementById("Widgetop").style.display = "block";
    }
    window.resizeTo(frontWidth, frontHeight);  
    widgetSetup();
    fillTimeZones();
    widget.onshow = readPrefs;
    widget.onhide = onhide;
    widget.onremove = clearPrefs;
    document.getElementById("Location").onclick = startTest;
    document.getElementById("Time").onclick = toggleTimeFormat;
    document.getElementById("Date").onclick = changeInfo;
    document.getElementById("MapImage").onclick = mapClicked;
    document.getElementById("Map").onclick = closeMap;
    
    pane = document.getElementById("BackPane");
    stars = document.getElementById("StarsPane");
    glow = document.getElementById("GlowPane");
    moon = document.getElementById("Moon");
    santa = document.getElementById("Santa");
    sun = document.getElementById("Sun");
    clouds = document.getElementById("CloudsPane");
    clock = document.getElementById("ClockPane");
    
    calcSun(13, -5, 38.833333, -77);
    var date = new Date();
    //calcSun(daysAfterMonth[date.getMonth()] + date.getDate(), 1, 52.5, 13.5);
    updateSunTimes();
    if (navigator.language) {
      show12Clock = navigator.language.toLowerCase().indexOf("en") >= 0 
        || date.toLocaleTimeString().toLowerCase().indexOf("am") >= 0
        || date.toLocaleTimeString().toLowerCase().indexOf("pm") >= 0;
    }    
  }  
}

function readPrefs() {
  var value = widget.preferenceForKey(widget.identifier + "-location");
  if (value != null) {
    city = value;    
    if (widget.mobile) {
      if (city.length > 0) {
        widget.mobile.setTitle(city);
      }
      else {
        widget.mobile.setTitle("World Clock");      
      }  
    }
  }
  document.getElementById("Location").innerHTML = city;
  document.getElementById("LocationInput").value = city;

  value = widget.preferenceForKey(widget.identifier + "-12clock");
  if (value != null) {
    show12Clock = value == "true";
  }
  
  value = widget.preferenceForKey(widget.identifier + "-seconds");
  if (value != undefined && value != null) {
    showSeconds = value != "false";
  }
  document.getElementById("SecondsCheck").checked = !showSeconds;
  
  value = widget.preferenceForKey(widget.identifier + "-zone");
  if (value != null) {
    timeZone = parseFloat(value);    
  }
  else {
    timeZone = -(getTimezoneOffset(new Date())) / 60;
  }
  document.getElementById("TimeZone").value = timeZone;

  value = widget.preferenceForKey(widget.identifier + "-dst");
  if (value != null) {
    dst = value == "true";    
  }
  else {
    dst = false;
  }
  document.getElementById("DstCheck").checked = dst;

  value = widget.preferenceForKey(widget.identifier + "-info");
  if (value != null) {
    infoIndex = parseInt(value);    
  }
  updateInfo();

  value = widget.preferenceForKey(widget.identifier + "-lat");
  if (value != null) {
    cityLat = parseFloat(value);    
  }
  value = widget.preferenceForKey(widget.identifier + "-long");
  if (value != null) {
    cityLong = parseFloat(value);    
  }
  document.getElementById("LatInput").value = cityLat;
  document.getElementById("LongInput").value = cityLong;

  if (interval) {
    clearInterval(interval);
  }
  interval = setInterval(update, 200);
  updateSunTimes();
}

function clearPrefs() {
  widget.setPreferenceForKey(null, widget.identifier + "-location");
  widget.setPreferenceForKey(null, widget.identifier + "-12clock");
  widget.setPreferenceForKey(null, widget.identifier + "-zone");
  widget.setPreferenceForKey(null, widget.identifier + "-info");
  widget.setPreferenceForKey(null, widget.identifier + "-lat");
  widget.setPreferenceForKey(null, widget.identifier + "-long");
  widget.setPreferenceForKey(null, widget.identifier + "-seconds");
  widget.setPreferenceForKey(null, widget.identifier + "-dst");
}

function onhide() {
  if (interval) {
    clearInterval(interval);
  }  
}

function fillTimeZones() {
  var select = document.getElementById("TimeZone");
  for (var i = -13; i < 14; i++) {
  	var option = document.createElement("option");
  	option.value = i;
  	if (i < 0) {
  	  option.innerHTML = "GMT " + i + ":00";
  	}
  	else {
  	  option.innerHTML = "GMT +" + i + ":00";  	  
  	}
  	select.appendChild(option);  
  }
  for (var i = specials.length - 1; i >= 0; i--) {
  	var option = document.createElement("option");
  	var value = specials[i];
  	option.value = value;
  	var min = Math.abs(parseInt((value - parseInt(value)) * 60));
  	if (value < 0) {
  	  option.innerHTML = "GMT " + parseInt(value) + ":" + min;
  	}
  	else {
  	  option.innerHTML = "GMT +" + parseInt(value) + ":" + min;  	  
  	}
  	if (parseInt(value) > 0) {
  	  value = parseInt(value) + 1;
  	}
  	var pre = select.options[13 + parseInt(value)];
  	select.insertBefore(option, pre);    	
  }
}
    
function startTest(event) {
  if (window.event) {
    event = window.event;
  }
  if (testh < 24 || sunset < 0) {
    testh = 24;
  }
  else {
    onhide();
    if (event.shiftKey) {
      testh = (sunset - dawn) / 60;
    }
    else {  
      testh = (sunrise - dawn) / 60;
    }  
    testmin = 0;
  }  
  test();
}

function test() {
	var date = new Date();
  date.setHours(testh);
  date.setMinutes(testmin);
  backPane(date);
  testmin++;
  if (testmin >= 60) {
    testmin = 0;
    testh++;
  }
  if (testh < Math.min(24, (sunset + dawn) / 60 + 1)) {
    setTimeout(test, 100);
  }
  else {
    readPrefs();
  }  
}  

function changeInfo() {
  infoIndex++;
  if (infoIndex > 2) {
    infoIndex = 0;
  }
  widget.setPreferenceForKey(infoIndex, widget.identifier + "-info");
  updateInfo();
}

function updateInfo(date) {
  if (date == null) {
    date = new Date();
  }
  var info = date.toLocaleDateString();
  if (infoIndex == 1) {
    updateSunTimes();
    if (sunrise < 0) {
      info = "No Sunset";
    }
    else if (sunset < 0) {
      info = "No Sunrise";
    }
    else {
      info = "\u2191 " + formatTime2(parseInt(sunrise / 60), 
                                     parseInt(sunrise % 60), 
                                     parseInt((sunrise - Math.floor(sunrise)) * 60)) 
             + " - \u2193 " + formatTime2(parseInt(sunset / 60), 
                                     parseInt(sunset % 60), 
                                     parseInt((sunset - Math.floor(sunset)) * 60)); 
    }
  }
  else if (infoIndex == 2) {
    var zone = timeZone;
    var min = Math.abs(parseInt((timeZone - parseInt(timeZone)) * 60));
    var gmt = dst ? "DST" : "GMT";
    if (zone == 0) {
      info = gmt;      
    }
    else if (zone > 0) {
      info = gmt + " +" + parseInt(timeZone) + ":" + min;
    }
    else {
      info = gmt + " -" + (-parseInt(timeZone)) + ":" + min;        
    }  
  }  
  document.getElementById("Date").innerHTML = info;
}
  
function update() {
  var date = new Date();
  if (lastSeconds == parseInt(date.getTime() / 1000)) {
    return;
  }
  update2(date);
}  
  
function update2(date) {  
  lastSeconds = parseInt(date.getTime() / 1000);
  var dstTime = dst ? 1 : 0;
  var offset = getTimezoneOffset(date);
  //date.setHours(date.getHours() + offset / 60 + timeZone + dstTime);
  date.setTime(date.getTime() + (offset / 60 + timeZone + dstTime) * 60 * 60000);
  backPane(date);
}

function backPane(date) {  
  document.getElementById("Time").innerHTML = formatTime(date);
  if (infoIndex == 0 || infoIndex == 2) {
    updateInfo(date);
  }
  if (lastDay != date.getDay()) {
    updateInfo(date);
    lastDay = date.getDay();
  }
  var minutes = date.getHours() * 60 + date.getMinutes();
  var night = minutes < sunrise || minutes >= sunset;
  if (night) {
    if (!isNight) {
      changeBorder("backb");
      updateSunTimes();
      updateInfo(date);
    }  
    setTextColorArray(nightTextColor);
    stars.style.opacity = "1.0";
    stars.style.visibility = "visible";
    glow.style.opacity = "0.0";
    glow.style.visibility = "visible";
    sun.style.visibility = "hidden";
    moon.style.visibility = "visible";
    var mins = minutes;
    if (mins < sunrise) {
      mins += 24 * 60;
    }
    var moonx = (mins - sunset) / (sunrise + (24*60 - sunset));
    moon.style.left = parseInt(10 + moonx * 160) + "px";
    moon.style.bottom = parseInt(-25 + 87 * Math.sin(moonx * Math.PI)) + "px"; 
    if (moonx > 0.3 && moonx < 0.7) {
      this.clock.style.overflow = "visible";
    }
    else {
      this.clock.style.overflow = "hidden";
    }
    var isSunrise = true;
    var dawnColor = dawnColorRise;
    var diff = minutes - sunrise;
    if (diff > 0) {
      diff = sunset - minutes;
      isSunrise = false;
      dawnColor = dawnColorSet;
    }
    if (diff > -dawn) {
      glow.style.opacity = "" + (1.0 + diff / dawn);
      glow.style.visibility = "visible";
      stars.style.opacity = "" + (-diff / dawn);
    }
    else {
      glow.style.visibility = "hidden";      
    }
    pane.style.backgroundColor = "rgb(" + nightColor[0] + "," + nightColor[1] + "," + nightColor[2] + ")";
    if (diff < 0 && diff > -dawn2) {
      pane.style.backgroundColor = getColor(nightColor, dawnColor, dawn2 + diff, dawn2);
      //setTextColor(getColor(nightTextColor, dawnTextColorRise, dawn2 + diff, dawn2));
      if (!isSunrise) {
        clouds.style.opacity = 1+diff/dawn2;
        clouds.style.visibility = "visible";
      }  
    }
    else {
      clouds.style.visibility = "hidden";
    }
    
    if ((date.getDate() == 24 && date.getMonth() == 11 && !isSunrise) || 
        (date.getDate() == 25 && date.getMonth() == 11 && isSunrise)) {
      moon.style.display = "none";
      santa.style.left = parseInt(moon.style.left) - 25 + "px";
      santa.style.bottom = moon.style.bottom;
      santa.style.display = "block";
    }
    else {
      moon.style.display = "block";
      santa.style.display = "none";
    }
      
  }
  else {
    if (isNight) {
      changeBorder("back");
      updateSunTimes();
      updateInfo(date);
    }
    setTextColorArray(dayTextColor);  
    stars.style.opacity = "0.0";
    stars.style.visibility = "hidden";
    glow.style.opacity = "0.0";
    glow.style.visibility = "hidden";
    moon.style.visibility = "hidden";
    sun.style.visibility = "visible";
    sunx = (minutes - sunrise) / (sunset - sunrise);
    sun.style.left = parseInt(10 + sunx * 160) + "px";
    sun.style.bottom = parseInt(-25 + 87 * Math.sin(sunx * Math.PI)) + "px"; 
    if (sunx > 0.3 && sunx < 0.7) {
      clock.style.overflow = "visible";
    }
    else {
      clock.style.overflow = "hidden";
    }  
    var isSunrise = true;
    var dawnColor = dawnColorRise;
    var diff = minutes - sunrise;
    if (diff > dawn) {
      diff = sunset - minutes;
      isSunrise = false;
      dawnColor = dawnColorSet;
    }
    if (diff < dawn) {
      glow.style.opacity = "" + (1.0 - diff / dawn);
      glow.style.visibility = "visible";
    }
    else {
      glow.style.visibility = "hidden";      
    }
    pane.style.backgroundColor = "rgb(" + dayColor[0] + "," + dayColor[1] + "," + dayColor[2] + ")";
    if (diff < dawn2) {
      pane.style.backgroundColor = getColor(dayColor, dawnColor, dawn2 - diff, dawn2);
      //setTextColor(getColor(dayTextColor, dawnTextColorRise, dawn2 - diff, dawn2));
      if (!isSunrise) {
        clouds.style.opacity = 1 - diff/dawn2;
        clouds.style.visibility = "visible";
      }  
    }    
    else {
      clouds.style.visibility = "hidden";
    }
  }
  isNight = night;
}

function getColor(fromColor, toColor, value, max) {
  var result = new Array(3);
  for (var i = 0; i < result.length; i++) {
    result[i] = parseInt(fromColor[i] + (toColor[i] - fromColor[i]) * value / max);  	
  }
  return "rgb(" + result[0] + "," + result[1] + "," + result[2] + ")";  
}

function setTextColorArray(colorArray) {
  var color = "rgb(" + colorArray[0] + "," + colorArray[1] + "," + colorArray[2] + ")";
  setTextColor(color);
}

function setTextColor(color) {
  document.getElementById("Time").style.color = color;
  document.getElementById("Date").style.color = color;      
  document.getElementById("Location").style.color = color;        
}

function changeBorder(prefix) {
  for (var i = 0; i < tableTd.length; i++) {
  	var element = document.getElementById("Table_" + tableTd[i]);
  	element.setAttribute("background", prefix + "_" + tableTd[i] + ".png");
  }
  for (var i = 0; i < tableImg.length; i++) {
  	var element = document.getElementById("Table_" + tableImg[i]);
  	element.src = prefix + "_" + tableImg[i] + ".png";
  }
  document.getElementById("Mask").style.backgroundImage = "url(mask_" + prefix + ".png)";
}

function updateSunTimes() {
  var date = new Date();
  var dstTime = dst ? 1 : 0;
  date.setTime(date.getTime() + (getTimezoneOffset(date) + (timeZone + dst) * 60) * 60000);
  calcSun(daysAfterMonth[date.getMonth()] + date.getDate(), timeZone + dst, cityLat, cityLong);  
}

function calcSun(day, zone, lat, lng) {
  // Formula from http://mathforum.org/library/drmath/view/56478.html
  var test = 0.39795 * Math.cos(0.2163108 + 2*Math.atan(0.9671396 * Math.tan(0.00860 * (day-186))));
  var p = Math.asin(test);
  
  var nom = Math.sin(0.83333*Math.PI/180) + Math.sin(lat*Math.PI/180)*Math.sin(p);
  var denom = Math.cos(lat*Math.PI/180)* Math.cos(p);

  test = nom/denom;
  
  if (Math.abs(test) > 1) {
    if (test > 0) {
      sunrise = -60;
      sunset = 25 * 60; //never
    }
    else {
      sunrise = 25 * 60;
      sunset = -60; //never      
    }  
    return;
  }

  var d = 24 - (24/Math.PI) * Math.acos(test);
  
  var shift = (zone*15 - lng) / 360.0 * 24 + 12;
  //alert((shift - d / 2) + " " + (shift + d / 2));
  sunrise = (shift - d / 2) * 60;
  sunset = (shift + d / 2) * 60;
}

function parseLatLong() {
  try {
    var lat = parseFloat(document.getElementById("LatInput").value);
    if (lat > -90 && lat < 90) {
      cityLat = lat;
      widget.setPreferenceForKey(cityLat, widget.identifier + "-lat");
    }
  }
  catch (e) {
    document.getElementById("LatInput").value = cityLat;
  }  
  try {
    var lng = parseFloat(document.getElementById("LongInput").value);
    if (lng > -180 && lng < 180) {
      cityLong = lng;
      widget.setPreferenceForKey(cityLong, widget.identifier + "-long");
    }
  }
  catch (e) {
    document.getElementById("LongInput").value = cityLong;    
  }  
}

function formatTime(date) {
  var hours = date.getHours();
  var minutes = date.getMinutes() + "";
  var seconds = lastSeconds % 60 + "";
  return formatTime2(date.getHours(), date.getMinutes(), lastSeconds % 60);
}

function formatTime2(hours, minutes, seconds) {
  var isPM = hours >= 12;
  if (show12Clock) {
    hours = hours % 12;
    if (hours == 0) {
      hours = 12;
    }
  }
  hours = hours + "";
  if (hours.length < 2 && !show12Clock) {
    hours = "0" + hours;
  }
  minutes = minutes + "";    
  if (minutes.length < 2) {
    minutes = "0" + minutes;
  }
  seconds = seconds + "";
  if (seconds.length < 2) {
    seconds = "0" + seconds;
  }
  if (showSeconds) {
    var result = hours + ":" + minutes + ":" + seconds;
  }
  else {
    var result = hours + ":" + minutes;    
  }  
  if (show12Clock) {
    if (isPM) {
      result += "<span class='timeExt'>PM</span>";
    }
    else {
      result += "<span class='timeExt'>AM</span>";
    }
  }
  return result;
}

function getTimezoneOffset(date) {
  var offset = date.getTimezoneOffset();
  var diff = -(date.getHours() - date.getUTCHours()) * 60;
  if (Math.abs(diff) != Math.abs(offset)) {
    if (diff > 0) {
      diff -= 24 * 60;
    }
    else {
      diff += 24 * 60;
    }  
  }
  if (diff != offset) {
    offset = -offset;
  }
  return offset;
}

function toggleTimeFormat() {
  show12Clock = !show12Clock;
  widget.setPreferenceForKey("" + show12Clock, widget.identifier + "-12clock");
  updateInfo();
  update2(new Date());
}

function showMap() {
  document.getElementById("Map").style.display = "block";
}

function closeMap() {
  document.getElementById("Map").style.display = "none";
}

function mapClicked(event) {
  if (window.event) {
    event = window.event;
  }
  var img = document.getElementById("MapImage");
  var x = img.width - (backWidth - event.clientX - 10);
  var y = img.height - (backHeight - event.clientY - 30);
  document.getElementById("LongInput").value = ((x / img.width - 0.5) * 360).toFixed(1);
  document.getElementById("LatInput").value = (-(y / img.height - 0.5) * 180).toFixed(1);
  closeMap();
}

function widgetSetup() {
  if (window.widget) {
  	var gDoneButton = new AppleGlassButton(document.getElementById("DoneButton"), 
  	                                      "Done", hideBack); 
  	var gDemoButton = new AppleGlassButton(document.getElementById("MapButton"), 
  	                                      "Map", showMap); 
	  var gInfoButton = new AppleInfoButton(document.getElementById("InfoButton"), 
	                                        document.getElementById("front"), 
	                                        "white", "black", showBack);
	  gInfoButton.setCircleOpacity(0.5);                                      
  }
}

function showBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
 
    backShown = true;
    front.style.display="none";
    if (window.innerWidth) {
      frontWidth = window.innerWidth;
      frontHeight = window.innerHeight;
    }
    else {
      frontWidth = document.documentElement.clientWidth;
      frontHeight = document.documentElement.clientHeight;
    }  
    window.resizeTo(backWidth, backHeight);
    if(window.widget)
        widget.prepareForTransition("ToBack");

    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hideBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
  
    city = document.getElementById("LocationInput").value;
    document.getElementById("Location").innerHTML = city;
    widget.setPreferenceForKey(city, widget.identifier + "-location");
    if (widget.mobile) {
      if (city.length > 0) {
        widget.mobile.setTitle(city);
      }
      else {
        widget.mobile.setTitle("World Clock");      
      }  
    }
        
    timeZone = parseFloat(document.getElementById("TimeZone").value);
    widget.setPreferenceForKey(timeZone, widget.identifier + "-zone");
    
    showSeconds = !document.getElementById("SecondsCheck").checked;
    widget.setPreferenceForKey("" + showSeconds, widget.identifier + "-seconds");
    
    dst = document.getElementById("DstCheck").checked;
    widget.setPreferenceForKey("" + dst, widget.identifier + "-dst");
    
    parseLatLong();
    updateSunTimes();
    updateInfo();
    
    backShown = false;
    back.style.display="none";
    window.resizeTo(frontWidth, frontHeight);  
    if (window.widget)
      widget.prepareForTransition("ToFront");
 
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}                                                
  